Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 2613)
@@ -9,4 +9,5 @@
    !!            3.3  ! 2009-05 (G. Garric, C. Bricaud) addition of the lim2_evp case
    !!             -   ! 2010-11 (G. Madec) ice-ocean stress computed at each ocean time-step
+   !!            4.0  ! 2011-01  (A. R. Porter, STFC Daresbury) dynamical allocation
    !!----------------------------------------------------------------------
 #if defined key_lim2
@@ -14,6 +15,8 @@
    !!   'key_lim2'                                    LIM 2.0 sea-ice model
    !!----------------------------------------------------------------------
-   !!   lim_sbc_flx_2  : update mass, heat and salt fluxes at the ocean surface
-   !!   lim_sbc_tau_2  : update i- and j-stresses, and its modulus at the ocean surface
+   !!   lim_sbc_alloc_2 : allocate the limsbc arrays
+   !!   lim_sbc_init    : initialisation
+   !!   lim_sbc_flx_2   : update mass, heat and salt fluxes at the ocean surface
+   !!   lim_sbc_tau_2   : update i- and j-stresses, and its modulus at the ocean surface
    !!----------------------------------------------------------------------
    USE par_oce          ! ocean parameters
@@ -36,7 +39,7 @@
    PRIVATE
 
-   PUBLIC   lim_sbc_flx_2     ! called by sbc_ice_lim_2
-   PUBLIC   lim_sbc_tau_2     ! called by sbc_ice_lim_2
-   PUBLIC   lim_sbc_alloc_2   ! called by nemogcm.F90
+   PUBLIC   lim_sbc_init_2     ! called by ice_init_2
+   PUBLIC   lim_sbc_flx_2      ! called by sbc_ice_lim_2
+   PUBLIC   lim_sbc_tau_2      ! called by sbc_ice_lim_2
 
    REAL(wp)  ::   r1_rdtice            ! = 1. / rdt_ice 
@@ -53,5 +56,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/LIM2 3.3 , UCL - NEMO Consortium (2010)
+   !! NEMO/LIM2 4.0 , UCL - NEMO Consortium (2011)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -63,17 +66,13 @@
       !!             ***  ROUTINE lim_sbc_alloc_2 ***
       !!-------------------------------------------------------------------
-      IMPLICIT none
       INTEGER :: lim_sbc_alloc_2
       !!-------------------------------------------------------------------
-
-      ALLOCATE(soce_0(jpi,jpj),   sice_0(jpi,jpj),   &
-               utau_oce(jpi,jpj), vtau_oce(jpi,jpj), &
-               tmod_io(jpi,jpj),                     &
-               Stat=lim_sbc_alloc_2)
-
-      IF(lim_sbc_alloc_2 /= 0)THEN
-         CALL ctl_warn('lim_sbc_alloc_2: failed to allocate arrays.')
-      END IF
-
+      !
+      ALLOCATE( soce_0(jpi,jpj) , utau_oce(jpi,jpj) ,                       &
+         &      sice_0(jpi,jpj) , vtau_oce(jpi,jpj) , tmod_io(jpi,jpj), STAT=lim_sbc_alloc_2)
+         !
+      IF( lk_mpp               )   CALL mpp_sum( lim_sbc_alloc_2 )
+      IF( lim_sbc_alloc_2 /= 0 )   CALL ctl_warn('lim_sbc_alloc_2: failed to allocate arrays.')
+      !
    END FUNCTION lim_sbc_alloc_2
 
@@ -121,27 +120,6 @@
          RETURN
       END IF
-      ! Set-up pointers to sub-arrays of 3d workspaces
-      zalb  => wrk_3d_4(:,:,1:1)
+      zalb  => wrk_3d_4(:,:,1:1)      ! Set-up pointers to sub-arrays of 3d workspaces
       zalbp => wrk_3d_5(:,:,1:1)
-
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'lim_sbc_flx_2 : LIM-2 sea-ice - surface boundary condition - Mass, heat & salt fluxes'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~   '
-         !
-         r1_rdtice = 1._wp / rdt_ice
-         !
-         soce_0(:,:) = soce                     ! constant SSS and ice salinity used in levitating sea-ice case
-         sice_0(:,:) = sice
-         !
-         IF( cp_cfg == "orca" ) THEN            ! decrease ocean & ice reference salinities in the Baltic sea 
-            WHERE( 14._wp <= glamt(:,:) .AND. glamt(:,:) <= 32._wp .AND.   &
-               &   54._wp <= gphit(:,:) .AND. gphit(:,:) <= 66._wp         ) 
-               soce_0(:,:) = 4._wp
-               sice_0(:,:) = 2._wp
-            END WHERE
-         ENDIF
-         !
-      ENDIF
 
       !------------------------------------------!
@@ -260,7 +238,6 @@
 
       IF( lk_cpl ) THEN          ! coupled case
-         ! Ice surface temperature 
          tn_ice(:,:,1) = sist(:,:)          ! sea-ice surface temperature       
-         ! Computation of snow/ice and ocean albedo
+         !                                  ! Computation of snow/ice and ocean albedo
          CALL albedo_ice( tn_ice, reshape( hicif, (/jpi,jpj,1/) ), reshape( hsnif, (/jpi,jpj,1/) ), zalbp, zalb )
          alb_ice(:,:,1) =  0.5 * ( zalbp(:,:,1) + zalb (:,:,1) )   ! Ice albedo (mean clear and overcast skys)
@@ -321,16 +298,6 @@
       !
       IF(.NOT. wrk_use(2, 1,2))THEN
-         CALL ctl_stop('lim_sbc_tau_2 : requested workspace arrays unavailable.')
-         RETURN
+         CALL ctl_stop('lim_sbc_tau_2 : requested workspace arrays unavailable.')   ;   RETURN
       END IF
-      !
-      IF( kt == nit000 .AND. lwp ) THEN         ! control print
-         WRITE(numout,*)
-         WRITE(numout,*) 'lim_sbc_tau_2 : LIM 2.0 sea-ice - surface ocean momentum fluxes'
-         WRITE(numout,*) '~~~~~~~~~~~~~ '
-         IF( lk_lim2_vp )   THEN   ;   WRITE(numout,*) '                VP  rheology - B-grid case'
-         ELSE                      ;   WRITE(numout,*) '                EVP rheology - C-grid case'
-         ENDIF
-      ENDIF
       !
       SELECT CASE( cp_ice_msh )     
@@ -446,9 +413,40 @@
          &                       tab2d_2=vtau, clinfo2=' vtau    : '        , mask2=vmask )
       !  
-      IF(.NOT. wrk_release(2, 1,2))THEN
-         CALL ctl_stop('lim_sbc_tau_2 : failed to release workspace arrays.')
-      END IF
-
+      IF(.NOT. wrk_release(2, 1,2) )   CALL ctl_stop('lim_sbc_tau_2 : failed to release workspace arrays.')
+      !
    END SUBROUTINE lim_sbc_tau_2
+
+
+   SUBROUTINE lim_sbc_init_2
+      !!-------------------------------------------------------------------
+      !!                  ***  ROUTINE lim_sbc_init  ***
+      !!             
+      !! ** Purpose : Preparation of the file ice_evolu for the output of
+      !!      the temporal evolution of key variables
+      !!
+      !! ** input   : Namelist namicedia
+      !!-------------------------------------------------------------------
+      !
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) 'lim_sbc_init_2 : LIM-2 sea-ice - surface boundary condition'
+      IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~~   '
+
+      !                                      ! allocate lim_sbc arrays
+      IF( lim_sbc_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'lim_sbc_flx_2 : unable to allocate arrays' )
+      !
+      r1_rdtice = 1._wp / rdt_ice
+      !
+      soce_0(:,:) = soce                     ! constant SSS and ice salinity used in levitating sea-ice case
+      sice_0(:,:) = sice
+      !
+      IF( cp_cfg == "orca" ) THEN            ! decrease ocean & ice reference salinities in the Baltic sea 
+         WHERE( 14._wp <= glamt(:,:) .AND. glamt(:,:) <= 32._wp .AND.   &
+            &   54._wp <= gphit(:,:) .AND. gphit(:,:) <= 66._wp         ) 
+            soce_0(:,:) = 4._wp
+            sice_0(:,:) = 2._wp
+         END WHERE
+      ENDIF
+      !
+   END SUBROUTINE lim_sbc_init_2
 
 #else
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limtab_2.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limtab_2.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limtab_2.F90	(revision 2613)
@@ -2,12 +2,11 @@
    !!======================================================================
    !!                       ***  MODULE limtab_2   ***
-   !!              transform 1D (2D) array to a 2D (1D) table
+   !!   LIM : transform 1D (2D) array to a 2D (1D) table
    !!======================================================================
 #if defined key_lim2
    !!----------------------------------------------------------------------
-   !!   tab_2d_1d  : 2-D to 1-D
-   !!   tab_1d_2d  : 1-D to 2-D
+   !!   tab_2d_1d  : 2-D <==> 1-D
+   !!   tab_1d_2d  : 1-D <==> 2-D
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE par_kind
 
@@ -15,66 +14,56 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC tab_2d_1d_2  ! called by lim_ther
-   PUBLIC tab_1d_2d_2  ! called by lim_ther
+   PUBLIC   tab_2d_1d_2   ! called by limthd
+   PUBLIC   tab_1d_2d_2   ! called by limthd
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM2 3.3 , UCL - NEMO Consortium (2010)
+   !! NEMO/LIM2 4.0 , UCL - NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
 
    SUBROUTINE tab_2d_1d_2 ( ndim1d, tab1d, tab2d, ndim2d_x, ndim2d_y, tab_ind )
-
-      INTEGER, INTENT(in) :: &
-         ndim1d, ndim2d_x, ndim2d_y
-
-      REAL(wp), DIMENSION (ndim2d_x, ndim2d_y), INTENT(in) ::  &
-         tab2d
-
-      INTEGER, DIMENSION ( ndim1d), INTENT ( in) :: &
-         tab_ind
-
-      REAL(wp), DIMENSION(ndim1d), INTENT ( out) ::  & 
-         tab1d
-
-      INTEGER ::  &
-         jn , jid, jjd
-        
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE tab_2d_1d  ***
+      !!----------------------------------------------------------------------
+      INTEGER                               , INTENT(in   ) ::   ndim1d, ndim2d_x, ndim2d_y   ! 1D & 2D sizes
+      REAL(wp), DIMENSION(ndim2d_x,ndim2d_y), INTENT(in   ) ::   tab2d                        ! input 2D field
+      INTEGER , DIMENSION(ndim1d)           , INTENT(in   ) ::   tab_ind                      ! input index
+      REAL(wp), DIMENSION(ndim1d)           , INTENT(  out) ::   tab1d                        ! output 1D field
+      !
+      INTEGER ::   jn , jid, jjd
+      !!----------------------------------------------------------------------
       DO jn = 1, ndim1d
-         jid        = MOD( tab_ind(jn) - 1, ndim2d_x ) + 1
-         jjd        = ( tab_ind(jn) - 1 ) / ndim2d_x + 1
+         jid        = MOD( tab_ind(jn) - 1 , ndim2d_x ) + 1
+         jjd        =    ( tab_ind(jn) - 1 ) / ndim2d_x + 1
          tab1d( jn) = tab2d( jid, jjd)
       END DO 
-
    END SUBROUTINE tab_2d_1d_2
 
 
    SUBROUTINE tab_1d_2d_2 ( ndim1d, tab2d, tab_ind, tab1d, ndim2d_x, ndim2d_y )
-
-      INTEGER, INTENT ( in) :: &
-         ndim1d, ndim2d_x, ndim2d_y
-
-      INTEGER, DIMENSION (ndim1d) , INTENT (in) :: &
-         tab_ind
-
-      REAL(wp), DIMENSION(ndim1d), INTENT (in) ::  &
-         tab1d  
-
-      REAL(wp), DIMENSION (ndim2d_x, ndim2d_y), INTENT ( out) :: &
-         tab2d
-
-      INTEGER :: &
-         jn, jid, jjd
-
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE tab_2d_1d  ***
+      !!----------------------------------------------------------------------
+      INTEGER                               , INTENT(in   ) ::   ndim1d, ndim2d_x, ndim2d_y   ! 1d & 2D sizes
+      REAL(wp), DIMENSION(ndim1d)           , INTENT(in   ) ::   tab1d                        ! input 1D field
+      INTEGER , DIMENSION(ndim1d)           , INTENT(in   ) ::   tab_ind                      ! input index
+      REAL(wp), DIMENSION(ndim2d_x,ndim2d_y), INTENT(  out) ::   tab2d                        ! output 2D field
+      !
+      INTEGER ::   jn , jid, jjd
+      !!----------------------------------------------------------------------
       DO jn = 1, ndim1d
-         jid             = MOD( tab_ind(jn) - 1, ndim2d_x) + 1
+         jid             = MOD( tab_ind(jn) - 1 , ndim2d_x ) + 1
          jjd             =    ( tab_ind(jn) - 1 ) / ndim2d_x  + 1
          tab2d(jid, jjd) = tab1d( jn)
       END DO
-
    END SUBROUTINE tab_1d_2d_2
 
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option        Dummy module             NO LIM sea-ice model
+   !!----------------------------------------------------------------------
 #endif
+   !!======================================================================
 END MODULE limtab_2
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limwri_2.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limwri_2.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limwri_2.F90	(revision 2613)
@@ -53,8 +53,7 @@
    INTEGER, ALLOCATABLE, SAVE, DIMENSION(:) :: ndex51   ! ????
 
-   REAL(wp)  ::            &  ! constant values
-      epsi16 = 1.e-16   ,  &
-      zzero  = 0.e0     ,  &
-      zone   = 1.e0
+   REAL(wp) ::   epsi16 = 1.e-16_wp   ! constant values
+   REAL(wp) ::   zzero  = 0._wp       !     -      -
+   REAL(wp) ::   zone   = 1._wp       !     -      -
 
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   zcmo      ! Workspace array for netcdf writer. 
@@ -68,5 +67,4 @@
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -78,11 +76,10 @@
       INTEGER :: lim_wri_alloc_2
       !!-------------------------------------------------------------------
-
-      ALLOCATE(ndex51(jpij), zcmo(jpi,jpj,jpnoumax), Stat=lim_wri_alloc_2)
-
-      IF(lim_wri_alloc_2 /= 0)THEN
-         CALL ctl_warn('lim_wri_alloc_2: failed to allocate array ndex51')
-      END IF
-
+      !
+      ALLOCATE( ndex51(jpij), zcmo(jpi,jpj,jpnoumax), STAT=lim_wri_alloc_2)
+      !
+      IF( lk_mpp               )   CALL mpp_sum( ierr )
+      IF( lim_wri_alloc_2 /= 0 )   CALL ctl_warn('lim_wri_alloc_2: failed to allocate array ndex51')
+      !
    END FUNCTION lim_wri_alloc_2
 
@@ -125,4 +122,5 @@
       IF( kt == nit000 ) THEN                    !   Initialisation   !
          !                                       !--------------------!
+
          CALL lim_wri_init_2 
                            
@@ -253,4 +251,8 @@
          field_19
       !!-------------------------------------------------------------------
+      !
+      IF( lim_wri_alloc_2() /= 0 ) THEN      ! allocate lim_wri arrrays
+         CALL ctl_stop( 'STOP', 'lim_wri_init_2 : unable to allocate standard arrays' )   ;   RETURN
+      ENDIF
 
       REWIND ( numnam_ice )                ! Read Namelist namicewri
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limwri_dimg_2.h90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limwri_dimg_2.h90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limwri_dimg_2.h90	(revision 2613)
@@ -18,20 +18,19 @@
     INTEGER, INTENT(in) ::   kt     ! number of iteration
 
-    REAL(wp),DIMENSION(1) ::   zdept
+    INTEGER , SAVE ::   nmoyice   !: counter for averaging
+    INTEGER , SAVE ::   nwf       !: number of fields to write on disk
+    INTEGER , SAVE, DIMENSION(:), ALLOCATABLE  :: nsubindex   !: subindex to be saved
+    INTEGER , SAVE ::   nice, nhorid, ndim, niter, ndepid
+    REAL(wp), SAVE, DIMENSION(jpi,jpj,jpnoumax) :: rcmoy
 
-    REAL(wp) :: &
-         zsto, zsec, zjulian,zout, &
-         zindh,zinda,zindb,  &
-         ztmu
-    REAL(wp), DIMENSION(jpi,jpj,jpnoumax) :: &
-         zcmo !ARPDBGWORK
-    REAL(wp), DIMENSION(jpi,jpj) ::  &
-         zfield
-    INTEGER, SAVE :: nmoyice, &  !: counter for averaging
-         &             nwf         !: number of fields to write on disk
-    INTEGER, SAVE,DIMENSION (:), ALLOCATABLE  :: nsubindex   !: subindex to be saved
-    ! according to namelist
+    INTEGER ::  ji, jj, jf, ii   ! dummy loop indices and array index
+    INTEGER :: iyear, iday, imon ! 
+    CHARACTER(LEN=80) :: clname, cltext, clmode
+    REAL(wp), DIMENSION(1) ::   zdept
+    REAL(wp) ::   zsto, zsec, zjulian,zout
+    REAL(wp) ::   zindh,zinda,zindb, ztmu
+    REAL(wp), DIMENSION(jpi,jpj,jpnoumax) ::   zcmo   !ARPDBGWORK
+    REAL(wp), DIMENSION(jpi,jpj)          ::   zfield
 
-    REAL(wp), SAVE, DIMENSION(jpi,jpj,jpnoumax) :: rcmoy
 #if ! defined key_diainstant
     LOGICAL, PARAMETER :: ll_dia_inst=.false.      ! local logical variable 
@@ -39,17 +38,8 @@
     LOGICAL, PARAMETER :: ll_dia_inst=.true.
 #endif
-    INTEGER ::  ji, jj, jf, ii   ! dummy loop indices and array index
-    INTEGER :: iyear, iday, imon ! 
+    !!-------------------------------------------------------------------
 
-    CHARACTER(LEN=80) :: clname, cltext, clmode
-
-
-    INTEGER , SAVE ::      &
-         nice, nhorid, ndim, niter, ndepid
-    INTEGER , DIMENSION( jpij ) , SAVE ::  &
-         ndex51  
-    !!-------------------------------------------------------------------
-    IF ( kt == nit000 ) THEN 
-
+    IF( kt == nit000 ) THEN 
+       !
        CALL lim_wri_init_2 
 
@@ -57,5 +47,5 @@
        ii  = 0
 
-       IF (lwp ) THEN
+       IF(lwp ) THEN
           WRITE(numout,*) 'lim_wri_2 : Write ice outputs in dimg'
           WRITE(numout,*) '~~~~~~~~'
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 2613)
@@ -32,7 +32,6 @@
    LOGICAL ::   ln_vol  = .false.     !: =T volume correction             
    LOGICAL ::   ln_mask = .false.     !: =T read bdymask from file
-   LOGICAL ::   ln_clim = .false.     !: if true, we assume that bdy data files contain 
-   !                                    !  1 time dump  (-->bdy forcing will be constant) 
-   !                                    !  or 12 months (-->bdy forcing will be cyclic) 
+   LOGICAL ::   ln_clim = .false.     !: =T bdy data files contain  1 time dump  (-->bdy forcing will be constant) 
+   !                                  !                         or 12 months     (-->bdy forcing will be cyclic) 
    LOGICAL ::   ln_dyn_fla  = .false. !: =T Flather boundary conditions on barotropic velocities
    LOGICAL ::   ln_dyn_frs  = .false. !: =T FRS boundary conditions on velocities
@@ -40,8 +39,8 @@
    LOGICAL ::   ln_ice_frs  = .false. !: =T FRS boundary conditions on seaice (leads fraction, ice depth, snow depth)
    !
-   INTEGER ::   nn_rimwidth = 7         !: boundary rim width
-   INTEGER ::   nn_dtactl   = 1	        !: = 0 use the initial state as bdy dta or = 1 read it in a NetCDF file
-   INTEGER ::   nn_volctl   = 1         !: = 0 the total volume will have the variability of the surface Flux E-P 
-   !                                    !  = 1 the volume will be constant during all the integration.
+   INTEGER ::   nn_rimwidth = 7       !: boundary rim width
+   INTEGER ::   nn_dtactl   = 1	     !: = 0 use the initial state as bdy dta ; = 1 read it in a NetCDF file
+   INTEGER ::   nn_volctl   = 1       !: = 0 the total volume will have the variability of the surface Flux E-P 
+   !                                  !  = 1 the volume will be constant during all the integration.
 
    !!----------------------------------------------------------------------
@@ -63,5 +62,5 @@
    INTEGER, DIMENSION(jpbdim,jpbgrd) ::   nbmap           !: Indices of data in file for data in memory 
     
-   REAL(wp) ::   bdysurftot	                          !: Lateral surface of unstructured open boundary
+   REAL(wp) ::   bdysurftot	                            !: Lateral surface of unstructured open boundary
 
    REAL(wp), DIMENSION(jpbdim)        ::   flagu, flagv   !: Flag for normal velocity compnt for velocity components
@@ -75,8 +74,29 @@
    REAL(wp), DIMENSION(jpbdim) ::   utide, vtide          !: Tidal boundary array : U and V
 #if defined key_lim2
-   REAL(wp), DIMENSION(jpbdim) ::  &
-      frld_bdy, hicif_bdy,  & !: Now clim of ice leads fraction, ice  
-      hsnif_bdy               !: thickness and snow thickness
+   REAL(wp), DIMENSION(jpbdim) ::   frld_bdy    !: now ice leads fraction climatology   
+   REAL(wp), DIMENSION(jpbdim) ::   hicif_bdy   !: Now ice  thickness climatology
+   REAL(wp), DIMENSION(jpbdim) ::   hsnif_bdy   !: now snow thickness
 #endif
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 4.0 , NEMO Consortium (2011)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   FUNCTION bdy_oce_alloc()
+      !!----------------------------------------------------------------------
+      INTEGER :: bdy_oce_alloc
+      !!----------------------------------------------------------------------
+      !
+      ALLOCATE( bdytmask(jpi,jpj) , tbdy(jpbdim,jpk) , sbdy(jpbdim,jpk) ,     &
+         &      bdyumask(jpi,jpj) , ubdy(jpbdim,jpk) ,                        &
+         &      bdyvmask(jpi,jpj) , vbdy(jpbdim,jpk) ,                    STAT=bdy_oce_alloc )
+         !
+      IF( lk_mpp             )   CALL mpp_sum ( bdy_oce_alloc )
+      IF( bdy_oce_alloc /= 0 )   CALL ctl_warn('bdy_oce_alloc: failed to allocate arrays.')
+      !
+   END FUNCTION bdy_oce_alloc
 
 #else
@@ -87,26 +107,4 @@
 #endif
 
-   !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
-#if defined key_bdy 
-CONTAINS
-
-   FUNCTION bdy_oce_alloc()
-      INTEGER :: bdy_oce_alloc
-
-      ALLOCATE(bdytmask(jpi,jpj), bdyumask(jpi,jpj), bdyvmask(jpi,jpj), &
-               tbdy(jpbdim,jpk),  sbdy(jpbdim,jpk),                     &
-               ubdy(jpbdim,jpk),  vbdy(jpbdim,jpk),                     &
-               Stat=bdy_oce_alloc)
- 
-      IF(bdy_oce_alloc /= 0)THEN
-         CALL ctl_warn('bdy_oce_alloc: failed to allocate arrays.')
-      END IF
-
-   END FUNCTION bdy_oce_alloc
-#endif
-
 END MODULE bdy_oce
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 2613)
@@ -33,7 +33,7 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2011)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
@@ -44,30 +44,27 @@
       !!         
       !! ** Purpose :   Initialization of the dynamics and tracer fields with 
-      !!      unstructured open boundaries.
+      !!              unstructured open boundaries.
       !!
-      !! ** Method  :  Read initialization arrays (mask, indices) to identify 
-      !!               an unstructured open boundary
+      !! ** Method  :   Read initialization arrays (mask, indices) to identify 
+      !!              an unstructured open boundary
       !!
       !! ** Input   :  bdy_init.nc, input file for unstructured open boundaries
       !!----------------------------------------------------------------------      
-      INTEGER ::   ii, ij, ik, igrd, ib, ir   ! dummy loop indices
-      INTEGER ::   icount, icountr
-      INTEGER ::   ib_len, ibr_max
-      INTEGER ::   iw, ie, is, in 
-      INTEGER ::   inum                 ! local logical unit
-      INTEGER ::   id_dummy             ! local integers
-      INTEGER ::   igrd_start, igrd_end ! start and end of loops on igrd
+      INTEGER  ::   ii, ij, ik, igrd, ib, ir   ! dummy loop indices
+      INTEGER  ::   icount, icountr, ib_len, ibr_max   ! local integers
+      INTEGER  ::   iw, ie, is, in, inum, id_dummy     !   -       -
+      INTEGER  ::   igrd_start, igrd_end               !   -       -
+      REAL(wp) ::   zefl, zwfl, znfl, zsfl              ! local scalars
       INTEGER, DIMENSION (2)             ::   kdimsz
       INTEGER, DIMENSION(jpbdta, jpbgrd) ::   nbidta, nbjdta   ! Index arrays: i and j indices of bdy dta
       INTEGER, DIMENSION(jpbdta, jpbgrd) ::   nbrdta           ! Discrete distance from rim points
-      REAL(wp) :: zefl, zwfl, znfl, zsfl                       ! temporary scalars
-      REAL(wp) , DIMENSION(jpidta,jpjdta) ::   zmask           ! global domain mask
-      REAL(wp) , DIMENSION(jpbdta,1)      ::   zdta            ! temporary array 
-      CHARACTER(LEN=80),DIMENSION(6)      ::   clfile
+      REAL(wp), DIMENSION(jpidta,jpjdta) ::   zmask            ! global domain mask
+      REAL(wp), DIMENSION(jpbdta,1)      ::   zdta             ! temporary array 
+      CHARACTER(LEN=80),DIMENSION(6)     ::   clfile
       !!
-      NAMELIST/nambdy/cn_mask, cn_dta_frs_T, cn_dta_frs_U, cn_dta_frs_V,          &
-         &            cn_dta_fla_T, cn_dta_fla_U, cn_dta_fla_V,              &
-         &            ln_tides, ln_clim, ln_vol, ln_mask,                &
-         &            ln_dyn_fla, ln_dyn_frs, ln_tra_frs,ln_ice_frs,     &
+      NAMELIST/nambdy/cn_mask, cn_dta_frs_T, cn_dta_frs_U, cn_dta_frs_V,   &
+         &            cn_dta_fla_T, cn_dta_fla_U, cn_dta_fla_V,            &
+         &            ln_tides, ln_clim, ln_vol, ln_mask,                  &
+         &            ln_dyn_fla, ln_dyn_frs, ln_tra_frs,ln_ice_frs,       &
          &            nn_dtactl, nn_rimwidth, nn_volctl
       !!----------------------------------------------------------------------
@@ -77,4 +74,7 @@
       IF(lwp) WRITE(numout,*) '~~~~~~~~'
       !
+      !                                      ! allocate bdy_oce arrays
+      IF( bdy_oce_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'bdy_init : unable to allocate arrays' )
+
       IF( jperio /= 0 )   CALL ctl_stop( 'Cyclic or symmetric,',   &
          &                               ' and unstructured open boundary condition are not compatible' )
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90	(revision 2613)
@@ -7,5 +7,5 @@
    !!            3.3  !  2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase + merge TRC-TRA
    !!----------------------------------------------------------------------
-#if defined key_diaar5
+#if defined key_diaar5   || defined key_esopa
    !!----------------------------------------------------------------------
    !!   'key_diaar5'  :                           activate ar5 diagnotics
@@ -50,12 +50,10 @@
       INTEGER :: dia_ar5_alloc
       !!----------------------------------------------------------------------
-
-      ALLOCATE(area(jpi,jpj), thick0(jpi,jpj), sn0(jpi,jpj,jpk), &
-               Stat=dia_ar5_alloc)
-
-      IF(dia_ar5_alloc /= 0)THEN
-         CALL ctl_warn('dia_ar5_alloc: failed to allocate arrays')
-      END IF
-
+      !
+      ALLOCATE( area(jpi,jpj), thick0(jpi,jpj) , sn0(jpi,jpj,jpk) , STAT=dia_ar5_alloc )
+      !
+      IF( lk_mpp             )   CALL mpp_sum ( dia_ar5_alloc )
+      IF( dia_ar5_alloc /= 0 )   CALL ctl_warn('dia_ar5_alloc: failed to allocate arrays')
+      !
    END FUNCTION dia_ar5_alloc
 
@@ -66,5 +64,4 @@
       !!
       !! ** Purpose :   compute and output some AR5 diagnostics
-      !!
       !!----------------------------------------------------------------------
       USE wrk_nemo, ONLY: wrk_use, wrk_release
@@ -82,6 +79,5 @@
           (.NOT. wrk_use(3, 1,2)) .OR. &
           (.NOT. wrk_use(4, 1)) )THEN
-         CALL ctl_stop('dia_ar5: requested workspace arrays unavailable')
-         RETURN
+         CALL ctl_stop('dia_ar5: requested workspace arrays unavailable')   ;   RETURN
       END IF
 
@@ -190,8 +186,10 @@
       !
       IF(.NOT. wrk_use(4, 1))THEN
-         CALL ctl_stop('dia_ar5_init: requested workspace array unavailable.')
-         RETURN
+         CALL ctl_stop('dia_ar5_init: requested workspace array unavailable.')   ;   RETURN
       END IF
       zsaldta => wrk_4d_1(:,:,:,1:2)
+
+      !                                      ! allocate dia_ar5 arrays
+      IF( dia_ar5_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'dia_ar5_init : unable to allocate arrays' )
 
       area(:,:) = e1t(:,:) * e2t(:,:) * tmask_i(:,:)
